/* Entry Point - musí být definován     */
ENTRY(Vectors)

/* Specifikace paměťových prostorů čipu */
MEMORY {
  RAM (xrw)       : ORIGIN = 0x20000000, LENGTH = 64K
  ROM (xr)        : ORIGIN = 0x08000000, LENGTH = 64K
}
/* Kam umístíme stack - navrch RAM */
_estack = ORIGIN(RAM) + LENGTH(RAM);
/* Definice výstupních sekcí       */
SECTIONS {
    .fixed : {
      _vect_tab = .;
      LONG(_estack);       /* Initial stack pointer */
      *(.rodata.Vectors)
      *(.text*)            /* .text*   sections (code)                              */
      *(.rodata*)          /* .rodata* sections (constants, strings, etc.)          */
      *(.eh_frame)
    } >RAM
    .reloc : {
      *(.data*)            /* .data* sections */
      *(.bss*)             /* .bss*  sections */
      *(COMMON)
    } >RAM

    /DISCARD/ : {
        *(.ARM.extab*)
        *(.ARM.exidx*)
    }
    /DISCARD/ : {
        *(.ARM.attributes*)
        *(.comment)
    }
}
