module periph;

import mmio;

final abstract class AHB1 {
    immutable uint address = 0x4002_0000;
}

final abstract class RCC   : Peripheral!(AHB1, 0x0000_3800) {
    final abstract class AHB1ENR : Register!(0x0030, Access.Byte_HalfWord_Word) {
         alias EntireRegister = BitField!(31, 0, Mutability.rw);
         alias GPIODEN        = Bit!(3, Mutability.rw);
         alias GPIOCEN        = Bit!(2, Mutability.rw);
         alias GPIOBEN        = Bit!(1, Mutability.rw);
         alias GPIOAEN        = Bit!(0, Mutability.rw);
    }
}
final abstract class GPIOD : Peripheral!(AHB1, 0x0000_0C00) {
    /************************************************************************************
     GPIO port mode register
    */
    final abstract class MODER : Register!(0x00, Access.Byte_HalfWord_Word)    {
        alias MODER15 = BitField!(31, 30, Mutability.rw);
        alias MODER14 = BitField!(29, 28, Mutability.rw);
        alias MODER13 = BitField!(27, 26, Mutability.rw);
        alias MODER12 = BitField!(25, 24, Mutability.rw);
        alias MODER11 = BitField!(23, 22, Mutability.rw);
        alias MODER10 = BitField!(21, 20, Mutability.rw);
        alias MODER9 = BitField!(19, 18, Mutability.rw);
        alias MODER8 = BitField!(17, 16, Mutability.rw);
        alias MODER7 = BitField!(15, 14, Mutability.rw);
        alias MODER6 = BitField!(13, 12, Mutability.rw);
        alias MODER5 = BitField!(11, 10, Mutability.rw);
        alias MODER4 = BitField!(9, 8, Mutability.rw);
        alias MODER3 = BitField!(7, 6, Mutability.rw);
        alias MODER2 = BitField!(5, 4, Mutability.rw);
        alias MODER1 = BitField!(3, 2, Mutability.rw);
        alias MODER0 = BitField!(1, 0, Mutability.rw);
    }
    /************************************************************************************
     GPIO port output data register
    */
    final abstract class ODR : Register!(0x14, Access.Byte_HalfWord_Word)    {
        alias EntireRegister = BitField!(31, 0, Mutability.rw);

        alias ODR15 = Bit!(15, Mutability.rw);
        alias ODR14 = Bit!(14, Mutability.rw);
        alias ODR13 = Bit!(13, Mutability.rw);
        alias ODR12 = Bit!(12, Mutability.rw);
        alias ODR11 = Bit!(11, Mutability.rw);
        alias ODR10 = Bit!(10, Mutability.rw);
        alias ODR9 = Bit!(9, Mutability.rw);
        alias ODR8 = Bit!(8, Mutability.rw);
        alias ODR7 = Bit!(7, Mutability.rw);
        alias ODR6 = Bit!(6, Mutability.rw);
        alias ODR5 = Bit!(5, Mutability.rw);
        alias ODR4 = Bit!(4, Mutability.rw);
        alias ODR3 = Bit!(3, Mutability.rw);
        alias ODR2 = Bit!(2, Mutability.rw);
        alias ODR1 = Bit!(1, Mutability.rw);
        alias ODR0 = Bit!(0, Mutability.rw);
    }
}

