//start.d
/**
  Blikání ledkou na STM32F0 Discovery v jazyce D.
*/
import trace;
import mmio;
import periph;
import gcc.attribute;

alias ISR = void function(); // Alias Interrupt Service Routine function pointers

// These are marked extern(C) to avoid name mangling, so we can refer to them in our linker script
extern (C) immutable ISR [3] Vectors = 
  [&OnReset, null, &OnHardFault];
  
/* Nejde jednoduše napsat v D. Modifikátor volatile byl vyňat z jazyka
   a shared používá threads, takže by byl asi zapotřebí nějaký wordaround,
   zapíšeme to tedy jako jednoduchou funkci v čistém C. Tento zápis překladač
   optimalizuje na jednoduchý return bez smyčky, bez optimalizace by to fungovalo.
void Delay (uint time) {
  while (time) {time -= 1;}
}
*/
// Lze kombinovat s C.
extern (C) void Delay (uint time);

void OnReset() {
    RCC.AHB1ENR.GPIODEN.value = true;   // jednotlivé bity jdou přes bitband region, což není moc čitelné
    // RCC.AHB1ENR.EntireRegister.value = 0x8;
    GPIOD.MODER.MODER15.value = 1;

    while(true) {
      Delay (250000);
      GPIOD.ODR.ODR15.value = !GPIOD.ODR.ODR15.value;
      // GPIOD.ODR.EntireRegister.value = (1 << 15) ^ GPIOD.ODR.EntireRegister.value;
    }
}

// Handle any hard faults here
void OnHardFault() {
    // Enter an infinite loop so we can use the debugger
    // to examine registers, memory, etc...
    while(true) { }
}
